# -*- coding: UTF-8 -*-
'''
    cartoonhd scraper for Exodus.
    Nov 9 2018 - Checked
    Oct 10 2018 - Cleaned and Checked

    Updated and refactored by someone.
    Originally created by others.
'''
import re,traceback,urllib,urlparse,json,base64,time,xbmc

from resources.lib.modules import cleantitle
from resources.lib.modules import cfscrape
from resources.lib.modules import source_utils
from resources.lib.modules import client
from resources.lib.modules import directstream

class source:
	def __init__(self):
		self.priority = 1
		self.language = ['en']
		self.domains = ['cmovies.tv', 'cmovies.video', 'cmovieshd.bz']
		self.base_link = 'https://cmovies.tv'
		self.search_link = '/film/%s/watching.html?ep=0'
		self.scraper = cfscrape.create_scraper()


	def movie(self, imdb, title, localtitle, aliases, year):
		try:
			title = cleantitle.geturl(title).replace('--', '-')
			url = self.base_link + self.search_link % title
			return url
		except:
			return


	def sources(self, url, hostDict, hostprDict):
		sources = []
		try:
			hostDict = hostDict + hostprDict

			r = self.scraper.get(url).content

			qual = re.compile('class="quality">(.+?)</span>').findall(r)
			for i in qual:
				info = i
				if '1080' in i:
					quality = '1080p'
				elif '720' in i:
					quality = '720p'
				else:
					quality = 'SD'
			u = re.compile('data-video="(.+?)"').findall(r)

			for url in u:
				if not url.startswith('http'):
					url =  "https:" + url
				if 'vidcloud' in url:
					r = self.scraper.get(url).content
					t = re.compile('data-video="(.+?)"').findall(r)
					for url in t:
						if not url.startswith('http'):
							url =  "https:" + url
						valid, host = source_utils.is_host_valid(url, hostDict)
						if valid and 'vidcloud' not in url:
							sources.append({'source': host, 'quality': quality, 'language': 'en', 'info': info, 'url': url, 'direct': False, 'debridonly': False})

				valid, host = source_utils.is_host_valid(url, hostDict)

				if valid and 'vidcloud' not in url:
					sources.append({'source': host, 'quality': quality, 'language': 'en', 'info': info, 'url': url, 'direct': False, 'debridonly': False})
			return sources
		except:
			source_utils.scraper_error('CMOVIESTV')
			return sources


	def resolve(self, url):
		return url
